function algo_cfs1and2_harness_run(obj)
% run harness and check the result

%% define combined harness test data dictionary
startpath=pwd;
fcnpath=fileparts(mfilename('fullpath'));
eval(sprintf('cd %s',fcnpath));

system('rm -rf algo_cfs1and2_harness_run.sldd');
Simulink.data.dictionary.create('algo_cfs1and2_harness_run.sldd');
dd=Simulink.data.dictionary.open('algo_cfs1and2_harness_run.sldd');
dd.addDataSource('algo_cfs1.sldd');
dd.addDataSource('algo_cfs2.sldd');
ddd=dd.getSection('Design Data');

% proc_in_bus
elems(1)=Simulink.BusElement;
elems(1).Name='cfs1_proc_out';
elems(1).DataType='Bus: algo_cfs1_procout';
elems(2)=Simulink.BusElement;
elems(2).Name='cfs2_proc_out';
elems(2).DataType='Bus: algo_cfs2_procout';

procinBus = Simulink.Bus;
procinBus.HeaderFile = '';
procinBus.Description = '';
procinBus.DataScope = 'Auto';
procinBus.Alignment = -1;
procinBus.Elements = elems;
clear elems;

% assign proc_in bus in combined data dictionary
ddd.addEntry('algo_cfs12_procin',procinBus);
%assignin('base','algo_cfs12_procin',procinBus);

%% add combined harness dd to single algorithms
dd=Simulink.data.dictionary.open('algo_cfs1.sldd');
dd.addDataSource('algo_cfs1and2_harness_run.sldd');
dd=Simulink.data.dictionary.open('algo_cfs2.sldd');
dd.addDataSource('algo_cfs1and2_harness_run.sldd');



% % load tunable control parameters from mds
% shot = 1; % shot reference
% obj.actualize(shot);
% 
% % SimIn object to customize configuration of Simulation run for test
% SimIn = Simulink.SimulationInput([obj.getname '_harness']);
% 
% % Custom parameters for this run to save outport data
% SimIn = SimIn.setModelParameter('SaveOutput','on'); % set to save outport signals
% SimIn = SimIn.setModelParameter('SignalLogging','on'); % set to save log signals
% SimIn = SimIn.setModelParameter('OutputSaveName','SimOut');
% SimIn = SimIn.setModelParameter('SaveFormat','Dataset');
% SimIn = SimIn.setModelParameter('StartTime',num2str(obj.gettiming().t_start));
% SimIn = SimIn.setModelParameter('StopTime',num2str(obj.gettiming().t_stop));
% SimIn = SimIn.setModelParameter('FixedStep',Simulink.data.dictionary.createnum2str(obj.gettiming().dt));
% 
% % simulate - simulate only single types to save time
% result = sim(SimIn);
% 
% % check output port data
% tp = Simulink.data.evalinGlobal(obj.getname,'algo_cfs1_tp.Value');
% fp = Simulink.data.evalinGlobal(obj.getname,'algo_cfs1_fp');
% 
% input = evalin('base','algo_cfs1_inbus1');
% input1  = input.signal1.Data;
% input2  = input.signal2.Data;
% 
% output1 = result.simout.signal1.Data;
% output2 = result.simout.signal2.Data;
% 
% size(input1)
% size(output1)
% 
% maxerror1 = 0.1;
% maxerror2 = 0.1; 
% assert(max(abs(output1 - input1.*tp.gain))<maxerror1,'Wrong output 1!');
% assert(max(abs(output2 - (input2.*tp.refmodel.gain+fp.refmodel.offset)))<maxerror2,'Wrong output 2!');

eval(sprintf('cd %s',startpath));

end
